import { defineComponent as h, ref as y, onMounted as P, onBeforeUnmount as L, watch as i, openBlock as w, createElementBlock as v } from "vue";
import * as E from "@grapecity/activereports/reportviewer";
import * as R from "@grapecity/activereports/reportdesigner";
import { ColorThemes as x } from "@grapecity/activereports/reportdesigner";
const T = /* @__PURE__ */ h({
  __name: "Viewer",
  props: {
    availableExports: {},
    mouseMode: {},
    renderMode: {},
    viewMode: {},
    zoom: {},
    fullscreen: { type: Boolean },
    toolbarVisible: { type: Boolean },
    sidebarVisible: { type: Boolean },
    language: {},
    theme: {},
    themeConfig: {},
    exportsSettings: {},
    panelsLayout: {},
    parameterPanelLocation: {},
    showParametersOnOpen: {},
    memoizeData: { type: Boolean },
    toolbarLayout: {},
    errorHandler: {},
    report: {}
  },
  emits: ["report-loaded", "document-loaded"],
  setup(c, { expose: u, emit: f }) {
    const t = c, l = f, g = y();
    let o;
    const n = [];
    return P(() => {
      if (!g.value)
        return;
      o = new E.Viewer(g.value, {
        language: t.language,
        themeConfig: t.themeConfig,
        PanelsLayout: t.panelsLayout,
        ParameterPanelLocation: t.parameterPanelLocation,
        memoizeData: t.memoizeData,
        ExportsSettings: t.exportsSettings,
        ToolbarLayout: t.toolbarLayout
      });
      const { report: { Uri: e = "", Params: s = {} } = {} } = t;
      if (e !== void 0 && e !== "") {
        const d = [];
        Object.keys(s).forEach(
          (p) => d.push({ Name: p, Value: s[p] })
        ), o.open(e, { ReportParams: d });
      }
      n.push(
        o.reportLoaded.register((d) => l("report-loaded", d)),
        o.documentLoaded.register((d) => l("document-loaded", d))
      );
    }), L(() => {
      n.forEach((e) => e()), o.dispose();
    }), i(() => t.sidebarVisible, (e) => {
      o.toggleSidebar(e);
    }), i(() => t.toolbarVisible, (e) => {
      o.toggleToolbar(e);
    }), i(() => t.fullscreen, (e) => {
      o.toggleFullScreen(e);
    }), i(() => t.availableExports, (e) => {
      e !== void 0 && (o.availableExports = e);
    }), i(() => t.mouseMode, (e) => {
      e !== void 0 && (o.mouseMode = e);
    }), i(() => t.renderMode, (e) => {
      e !== void 0 && (o.renderMode = e);
    }), i(() => t.viewMode, (e) => {
      e !== void 0 && (o.viewMode = e);
    }), i(() => t.zoom, (e) => {
      e !== void 0 && (o.zoom = e);
    }), i(() => t.showParametersOnOpen, (e) => {
      e !== void 0 && (o.showParametersOnOpen = e);
    }), i(() => t.errorHandler, (e) => {
      e !== void 0 && (o.errorHandler = e);
    }), i(() => t.theme, (e) => {
      e !== void 0 && (o.theme = e);
    }), u({
      open(e, s) {
        if (!o)
          throw new Error("Viewer is not initialized yet");
        return o.open(e, s);
      },
      export(e, s, d) {
        if (!o)
          throw new Error("Viewer is not initialized yet");
        return o.export(e, s, d);
      },
      resetDocument() {
        return o.resetDocument();
      },
      print() {
        o.print();
      },
      Viewer() {
        return o;
      },
      currentPage() {
        return o.currentPage;
      },
      pageCount() {
        return o.pageCount;
      },
      history() {
        return o.history;
      },
      toolbar() {
        return o.toolbar;
      },
      goToFirstPage() {
        o.goToFirstPage();
      },
      goToPrevPage() {
        o.goToPrevPage();
      },
      goToNextPage() {
        o.goToNextPage();
      },
      goToLastPage() {
        o.goToLastPage();
      },
      goToPage(e) {
        o.goToPage(e);
      },
      backToParent() {
        o.backToParent();
      },
      refresh() {
        o.refresh();
      },
      canBackToParent() {
        return o.canBackToParent();
      },
      registerFont(...e) {
        return o.registerFont(...e);
      },
      search(e, s, d, p) {
        return o.search(e, s, d, p);
      },
      highlight(e) {
        return o.highlight(e);
      }
    }), (e, s) => (w(), v("div", {
      ref_key: "hostElement",
      ref: g,
      style: { height: "100%" }
    }, null, 512));
  }
}), D = /* @__PURE__ */ h({
  __name: "Designer",
  props: {
    report: {},
    onCreate: { type: Function },
    onOpen: { type: Function },
    onSave: { type: Function },
    onSaveAs: { type: Function },
    onRender: { type: Function },
    onOpenFileMenu: { type: Function },
    imageList: {},
    reportList: {},
    masterReportList: {},
    themeList: {},
    dataSources: {},
    onInit: { type: Function }
  },
  emits: ["document-changed"],
  setup(c, { expose: u, emit: f }) {
    const t = c, l = f, g = y();
    let o, n;
    function e() {
      n.setActionHandlers({
        onCreate: t.onCreate,
        onOpen: t.onOpen,
        onSave: t.onSave,
        onSaveAs: t.onSaveAs,
        onRender: t.onRender,
        onOpenFileMenu: t.onOpenFileMenu
      });
    }
    function s() {
      n.setResourceProvider({
        getImagesList: async () => t.imageList || [],
        getReportsList: async () => t.reportList || [],
        getMasterReportList: async () => t.masterReportList || [],
        getThemesList: async () => t.themeList || []
      });
    }
    function d(r) {
      return !!(r != null && r.definition);
    }
    function p(r, a) {
      return (d(r) && r.definition) !== (d(r) && r.definition) || (r == null ? void 0 : r.id) !== (a == null ? void 0 : a.id) || (r == null ? void 0 : r.displayName) !== (a == null ? void 0 : a.displayName);
    }
    return P(() => {
      var a;
      if (!g.value)
        return;
      const r = (a = t.onInit) == null ? void 0 : a.call(t);
      n = new R.Designer(g.value, r), e(), s(), t.dataSources && n.setDataSourceTemplates(t.dataSources), t.report && n.setReport(t.report, "override"), o = n.documentChanged.register(
        (m) => l("document-changed", m)
      );
    }), L(() => {
      o();
    }), i(() => t.onCreate, e), i(() => t.onOpen, e), i(() => t.onSave, e), i(() => t.onSaveAs, e), i(() => t.onRender, e), i(() => t.onOpenFileMenu, e), i(() => t.imageList, s), i(() => t.reportList, s), i(() => t.masterReportList, s), i(() => t.themeList, s), i(() => t.dataSources, (r) => {
      r && n.setDataSourceTemplates(r);
    }), i(() => t.report, (r, a) => {
      r && a && p(r, a) && (r ? n.setReport(r, "override") : n.createReport({ reportType: "CPL" }, "override"));
    }), u({
      setReport(r, a, m) {
        if (!n)
          throw new Error("Designer is not initialized yet");
        return n.setReport(r, a, m);
      },
      getReport() {
        if (!n)
          throw new Error("Designer is not initialized yet");
        return n.getReport();
      },
      createReport(r, a) {
        if (!n)
          throw new Error("Designer is not initialized yet");
        return n.createReport(r, a);
      },
      processCommand(r) {
        if (!n)
          throw new Error("Designer is not initialized yet");
        return n.processCommand(r);
      },
      focus() {
        if (!n)
          throw new Error("Designer is not initialized yet");
        n.focus();
      },
      getEditorAPI() {
        if (!n)
          throw new Error("Designer is not initialized yet");
        return n.getEditorAPI();
      },
      getPanelsAPI() {
        if (!n)
          throw new Error("Designer is not initialized yet");
        return n.getPanelsAPI();
      },
      getNotificationsAPI() {
        if (!n)
          throw new Error("Designer is not initialized yet");
        return n.getNotificationsAPI();
      }
    }), (r, a) => (w(), v("div", {
      ref_key: "hostElement",
      ref: g,
      style: { height: "100%" }
    }, null, 512));
  }
});
export {
  x as ColorThemes,
  D as Designer,
  T as Viewer
};
